From 7ce59fc9e86e42d804243e04957db969a64e93ad Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 11 2020 18:53:29 +0000
Subject: [PATCH 252/2232] Add in_place constructor for Box


---

diff --git a/include/cxx.h b/include/cxx.h
index 338dafe..157c31e 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -132,6 +132,14 @@ public:
   T *operator->() noexcept { return this->ptr; }
   T &operator*() noexcept { return *this->ptr; }
 
+  template <typename... Fields>
+  static Box in_place(Fields&&... fields) {
+    Box box;
+    box.uninit();
+    ::new (box.ptr) T{std::forward<Fields>(fields)...};
+    return box;
+  }
+
   // Important: requires that `raw` came from an into_raw call. Do not pass a
   // pointer from `new` or any other source.
   static Box from_raw(T *raw) noexcept {

